Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Graph.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Graph.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Graph.cs	(revision 8516)
@@ -0,0 +1,184 @@
+﻿
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.Utilities;
+namespace HeuristicLab.Problems.RoutePlanning.RoutingGraph {
+  public class Graph : IGraph {
+    private IDictionary<long, Vertex> vertices;
+    private IDictionary<long, List<Edge<Vertex>>> adjacencyMap;
+    private IDictionary<long, List<Edge<Vertex>>> incidenceMap;
+
+    public Graph() {
+      vertices = new Dictionary<long, Vertex>();
+      adjacencyMap = new Dictionary<long, List<Edge<Vertex>>>();
+      incidenceMap = new Dictionary<long, List<Edge<Vertex>>>();
+    }
+
+    public void AddVertex(Vertex vertex) {
+      if (!vertices.ContainsKey(vertex.Id)) {
+        vertices.Add(vertex.Id, vertex);
+      }
+    }
+
+    public Vertex GetVertex(long id) {
+      Vertex vertex = null;
+      vertices.TryGetValue(id, out vertex);
+      return vertex;
+    }
+
+    public List<Vertex> GetVertices() {
+      return new List<Vertex>(vertices.Values);
+    }
+
+    public void AddEdge(long startId, long endId) {
+      Vertex start = GetVertex(startId);
+      if (start == null) throw new ArgumentException(string.Format("Invalid vertex id {0}", startId), "startId");
+      Vertex end = GetVertex(startId);
+      if (end == null) throw new ArgumentException(string.Format("Invalid vertex id {0}", endId), "endId");
+
+      Edge<Vertex> edge = new Edge<Vertex>(start, end);
+      //edge.Category = -1
+
+      AddEdge(edge);
+    }
+
+    public void AddEdge(Edge<Vertex> edge) {
+      if (!adjacencyMap.ContainsKey(edge.Source.Id)) {
+        adjacencyMap.Add(edge.Source.Id, new List<Edge<Vertex>>());
+      }
+      adjacencyMap[edge.Source.Id].Add(edge);
+
+      if (!incidenceMap.ContainsKey(edge.Target.Id)) {
+        incidenceMap.Add(edge.Target.Id, new List<Edge<Vertex>>());
+      }
+      incidenceMap[edge.Target.Id].Add(edge);
+    }
+
+    public void RemoveEdge(long startId, long endId) {
+      Edge<Vertex> edge = GetEdge(startId, endId);
+      if (edge != null) {
+        adjacencyMap[startId].Remove(edge);
+        incidenceMap[endId].Remove(edge);
+      }
+    }
+
+    public bool HasEdge(long startId, long endId) {
+      Edge<Vertex> edge = GetEdge(startId, endId);
+      return (edge != null);
+    }
+
+    public Edge<Vertex> GetEdge(long startId, long endId) {
+      List<Edge<Vertex>> edges = adjacencyMap[startId];
+      foreach (Edge<Vertex> edge in edges) {
+        if (edge.Target.Id == endId) {
+          return edge;
+        }
+      }
+      return null;
+    }
+
+    public List<Edge<Vertex>> GetInEdges(long vertexId) {
+      List<Edge<Vertex>> edges;
+      if (incidenceMap.TryGetValue(vertexId, out edges)) {
+        return edges;
+      } else {
+        return new List<Edge<Vertex>>();
+      }
+    }
+
+    public int GetInDegree(long vertexId) {
+      return incidenceMap[vertexId].Count;
+    }
+
+    public List<Edge<Vertex>> GetOutEdges(long vertexId) {
+      List<Edge<Vertex>> edges;
+      if (adjacencyMap.TryGetValue(vertexId, out edges)) {
+        return edges;
+      } else {
+        return new List<Edge<Vertex>>();
+      }
+
+    }
+
+    public int GetOutDegree(long vertexId) {
+      return adjacencyMap[vertexId].Count;
+    }
+
+    public List<Edge<Vertex>> GetEdges(long vertexId) {
+      List<Edge<Vertex>> result = new List<Edge<Vertex>>();
+      foreach (Edge<Vertex> edge in GetInEdges(vertexId)) {
+        if (!result.Contains(edge)) {
+          result.Add(edge);
+        }
+      }
+      foreach (Edge<Vertex> edge in GetOutEdges(vertexId)) {
+        if (!result.Contains(edge)) {
+          result.Add(edge);
+        }
+      }
+      return result;
+    }
+
+    public Dictionary<long, float> GetNeighborsWithWeight(long id) {
+      Dictionary<long, float> neighbors = new Dictionary<long, float>();
+      List<Edge<Vertex>> edges = GetOutEdges(id);
+      foreach (Edge<Vertex> edge in edges) {
+        // TODO: check if edge can be traversed (eg. highway tag for car roads, ...)
+        float weight = GetWeight(edge); // TODO:  edge.Weight?
+        neighbors[edge.Target.Id] = weight;
+      }
+      return neighbors;
+    }
+    public Dictionary<long, float> GetNeighborsWithWeightReversed(long id) {
+      Dictionary<long, float> neighbors = new Dictionary<long, float>();
+      List<Edge<Vertex>> edges = GetInEdges(id);
+      foreach (Edge<Vertex> edge in edges) {
+        // TODO: check if edge can be traversed (eg. highway tag for car roads, ...)
+        float weight = GetWeight(edge); // TODO:  edge.Weight?
+        neighbors[edge.Source.Id] = weight;
+      }
+      return neighbors;
+    }
+
+    public float GetWeight(Edge<Vertex> edge) {
+      //double distance = Utils.Distance(edge.Source.Logitude, edge.Source.Latitude,
+      //                                 edge.Target.Logitude, edge.Target.Latitude);
+
+      PointD s = new PointD(edge.Source.Logitude, edge.Source.Latitude);
+      PointD t = new PointD(edge.Target.Logitude, edge.Target.Latitude);
+      double distance = Utils.LocationDistance(s, t);
+
+      int speed = edge.GetMaxSpeed();
+      double weight = (distance / speed) * 60;
+      //double weight = (distance / speed) * 3.6;
+      //double weight = (distance / speed);
+      //double weight = distance;
+      return (float)weight;
+    }
+
+    public float EstimatedCosts(long sourceId, long targetId) {
+      Vertex source = GetVertex(sourceId);
+      Vertex target = GetVertex(targetId);
+      return EstimatedCosts(source, target);
+    }
+
+    public float EstimatedCosts(Vertex source, Vertex target) {
+      //double distance = Utils.Distance(source.Logitude, source.Latitude,
+      //                                 target.Logitude, target.Latitude);
+
+      PointD s = new PointD(source.Logitude, source.Latitude);
+      PointD t = new PointD(target.Logitude, target.Latitude);
+      double distance = Utils.LocationDistance(s, t);
+
+      //int speed = 130;
+      //int speed = 10;
+      int speed = 130;
+      double costs = (distance / speed) * 60;
+      //double costs = (distance / speed) * 3.6;
+      //double costs = (distance / speed);
+      //double costs = distance;
+      return (float)costs;
+    }
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/TravelTimeCostCalculator.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/TravelTimeCostCalculator.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/TravelTimeCostCalculator.cs	(revision 8516)
@@ -0,0 +1,30 @@
+﻿
+using HeuristicLab.Problems.RoutePlanning.Interfaces;
+using HeuristicLab.Problems.RoutePlanning.Utilities;
+namespace HeuristicLab.Problems.RoutePlanning.RoutingGraph {
+  public class TravelTimeCostCalculator : ICostCalculator {
+    #region CostCalculator Members
+
+    public float Costs(Edge<Vertex> edge) {
+      double distance = Utils.Distance(edge.Source.Logitude, edge.Source.Latitude,
+                                       edge.Target.Logitude, edge.Target.Latitude);
+      //double distance = Utils.LocationDistance(source.Node.Point, target.Node.Point);
+      int speed = edge.GetMaxSpeed();
+      double weight = (distance / speed) * 3.6;
+      //double weight = (distance / speed);
+      return (float)weight;
+    }
+
+    public float EstimatedCosts(Vertex source, Vertex destination) {
+      double distance = Utils.Distance(source.Logitude, source.Latitude,
+                                       destination.Logitude, destination.Latitude);
+      //double distance = Utils.LocationDistance(source.Node.Point, target.Node.Point);
+      int speed = 130;
+      double costs = (distance / speed) * 3.6;
+      //double costs = (distance / speed);
+      return (float)costs;
+    }
+
+    #endregion
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Vertex.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Vertex.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/RoutingGraph/Vertex.cs	(revision 8516)
@@ -0,0 +1,67 @@
+﻿
+namespace HeuristicLab.Problems.RoutePlanning.RoutingGraph {
+  public class Vertex {
+    private long id;
+    public long Id {
+      get { return id; }
+      set { id = value; }
+    }
+
+    private double longitude;
+    public double Logitude {
+      get { return longitude; }
+      set { longitude = value; }
+    }
+
+    private double latitude;
+    public double Latitude {
+      get { return latitude; }
+      set { latitude = value; }
+    }
+
+    public Vertex(long id) {
+      this.id = id;
+    }
+
+    public Vertex(long id, double longitude, double latitude) {
+      this.id = id;
+      this.longitude = longitude;
+      this.latitude = latitude;
+    }
+
+    public static bool operator ==(Vertex v1, Vertex v2) {
+      if ((object)v1 == null) {
+        if ((object)v2 == null) {
+          return true;
+        }
+        return false;
+      }
+      if ((object)v1 == null && (object)v2 != null) {
+        return false;
+      }
+      return v1.Equals(v2);
+    }
+
+    public static bool operator !=(Vertex v1, Vertex v2) {
+      return !(v1 == v2);
+    }
+
+    public override bool Equals(object obj) {
+      if (obj is Vertex) {
+        Vertex v = (obj as Vertex);
+        return (this.id == v.id); //TODO:
+      }
+      return false;
+    }
+
+    public override int GetHashCode() {
+      return id.GetHashCode() ^ latitude.GetHashCode() ^ longitude.GetHashCode();
+    }
+
+    public override string ToString() {
+      return string.Format("{0}", id);
+    }
+
+
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/PointD.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/PointD.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/PointD.cs	(revision 8516)
@@ -0,0 +1,55 @@
+﻿
+using System.Drawing;
+
+namespace HeuristicLab.Problems.RoutePlanning.Utilities {
+  public struct PointD {
+    public double X;
+    public double Y;
+
+    #region Constructors
+
+    public PointD(double x, double y) {
+      this.X = x;
+      this.Y = y;
+    }
+
+    public PointD(PointD p) {
+      this.X = p.X;
+      this.Y = p.Y;
+    }
+
+    #endregion
+
+    #region Operators
+
+    public static bool operator !=(PointD left, PointD right) {
+      return left.X != right.X || left.Y != right.Y;
+    }
+
+    public static bool operator ==(PointD left, PointD right) {
+      return left.X == right.X && left.Y == right.Y;
+    }
+
+    public static explicit operator PointF(PointD p) {
+      return new PointF((float)p.X, (float)p.Y);
+    }
+
+    #endregion
+
+    #region Overridden Methods
+
+    public override bool Equals(object obj) {
+      if (obj is PointD) {
+        PointD p = (PointD)obj;
+        return (this.X == p.X && this.Y == p.Y);
+      }
+      return false;
+    }
+
+    public override int GetHashCode() {
+      return ((PointF)this).GetHashCode();
+    }
+
+    #endregion
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/RectangleD.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/RectangleD.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/RectangleD.cs	(revision 8516)
@@ -0,0 +1,98 @@
+﻿using System;
+using System.Drawing;
+
+namespace HeuristicLab.Problems.RoutePlanning.Utilities {
+  public class RectangleD {
+    private const int Digits = 4;
+    private double x;
+    private double y;
+    private double width;
+    private double height;
+
+    #region Properties
+
+    public double X {
+      get { return Math.Round(x, Digits); }
+      set { x = value; }
+    }
+
+    public double Y {
+      get { return Math.Round(y, Digits); }
+      set { y = value; }
+    }
+
+    public double Width {
+      get { return Math.Round(width, Digits); }
+      set { width = value; }
+    }
+
+    public double Height {
+      get { return Math.Round(height, Digits); }
+      set { height = value; }
+    }
+
+    public PointD TopLeft {
+      get { return new PointD(X, Y); }
+    }
+
+    public PointD BottomRight {
+      get { return new PointD(X + Width, Y + Height); }
+    }
+
+    public PointD Center {
+      get { return new PointD(X + Width / 2d, Y + Height / 2d); }
+    }
+
+    public double MaxSide {
+      get { return Math.Max(width, height); }
+    }
+
+    public double MinSide {
+      get { return Math.Min(width, height); }
+    }
+
+    #endregion
+
+    #region Constructors
+
+    public RectangleD(double x, double y, double w, double h) {
+      this.x = x;
+      this.y = y;
+      this.width = w;
+      this.height = h;
+    }
+
+    public RectangleD(RectangleD r) {
+      x = r.X;
+      y = r.Y;
+      width = r.Width;
+      height = r.Height;
+    }
+
+    #endregion
+
+    #region Operators
+
+    public static explicit operator RectangleF(RectangleD r) {
+      return new RectangleF((float)r.X, (float)r.Y, (float)r.Width, (float)r.Height);
+    }
+
+    #endregion
+
+    #region Overridden Methods
+
+    public override bool Equals(object obj) {
+      if (obj is RectangleD) {
+        RectangleD r = (RectangleD)obj;
+        return (X == r.X && Y == r.Y && Width == r.Width && Height == r.Height);
+      }
+      return false;
+    }
+
+    public override int GetHashCode() {
+      return ((RectangleF)this).GetHashCode();
+    }
+
+    #endregion
+  }
+}
Index: /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/Utils.cs
===================================================================
--- /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/Utils.cs	(revision 8516)
+++ /branches/RoutePlanning/HeuristicLab.Problems.RoutePlanning/3.3/Utilities/Utils.cs	(revision 8516)
@@ -0,0 +1,84 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.RoutePlanning.Utilities {
+  public static class Utils {
+    public static double Distance(PointD p1, PointD p2) {
+      double dx = p2.X - p1.X;
+      double dy = p2.Y - p1.Y;
+      return Math.Sqrt(dx * dx + dy * dy);
+    }
+
+    public static double Distance(double startX, double startY, double endX, double endY) {
+      double dx = endX - startX;
+      double dy = endY - startY;
+      return Math.Sqrt(dx * dx + dy * dy);
+    }
+
+    public static double LocationDistance(PointD p1, PointD p2) {
+      // The Haversine formula
+      /* dlon = lon2 - lon1
+            dlat = lat2 - lat1
+            a = (sin(dlat/2))^2 + cos(lat1) * cos(lat2) * (sin(dlon/2))^2
+            c = 2 * atan2(sqrt(a), sqrt(1-a)) 
+            d = R * c
+       */
+
+      double lat1Rad = p1.Y * (Math.PI / 180.0);
+      double long1Rad = p1.X * (Math.PI / 180.0);
+      double lat2Rad = p2.Y * (Math.PI / 180.0);
+      double long2Rad = p2.X * (Math.PI / 180.0);
+
+      double longitude = long2Rad - long1Rad;
+      double latitude = lat2Rad - lat1Rad;
+
+      double a = Math.Pow(Math.Sin(latitude / 2.0), 2.0) +
+                   Math.Cos(lat1Rad) * Math.Cos(lat2Rad) *
+                   Math.Pow(Math.Sin(longitude / 2.0), 2.0);
+
+      double c = 2.0 * Math.Asin(Math.Sqrt(a));
+
+      const double earthRadiusKms = 6376.5;
+      double distance = earthRadiusKms * c;
+
+      return distance;
+    }
+
+    public static double PathLength(IList<PointD> points) {
+      double length = 0;
+      for (int i = 1; i < points.Count; i++) {
+        length += Distance((PointD)points[i - 1], (PointD)points[i]);
+      }
+      return length;
+    }
+
+    public static RectangleD FindBox(IList<PointD> points) {
+      double minX = double.MaxValue;
+      double maxX = double.MinValue;
+      double minY = double.MaxValue;
+      double maxY = double.MinValue;
+
+      foreach (PointD p in points) {
+        if (p.X < minX)
+          minX = p.X;
+        if (p.X > maxX)
+          maxX = p.X;
+
+        if (p.Y < minY)
+          minY = p.Y;
+        if (p.Y > maxY)
+          maxY = p.Y;
+      }
+      return new RectangleD(minX, minY, maxX - minX, maxY - minY);
+    }
+
+    public static double PathDistance(IList<PointD> path1, IList<PointD> path2) {
+      double distance = 0;
+      for (int i = 0; i < path1.Count; i++) {
+        distance += Distance((PointD)path1[i], (PointD)path2[i]);
+      }
+      return distance / path1.Count;
+    }
+  }
+}
+
